import { appLogger } from '#application/logger'
import passwordResetTokenRepository from '#repositories/passwordResetTokenRepository'

class PasswordResetTokenService {
  /**
   * Delete token
   * @param token
   */
  public async delete(token: string): Promise<boolean> {
    try {
      const tokenData = await passwordResetTokenRepository.getByToken(token)
      if (!tokenData) {
        return false
      }

      await tokenData.delete()

      return true
    } catch (error: any) {
      appLogger.error(`Error deleting password reset token: ${error instanceof Error ? error.message : String(error)}`)
      return false
    }
  }
}

export default PasswordResetTokenService
