import { Server } from 'socket.io'

import Database from '#application/database'
import { TSocket } from '#application/types'
import { CharacterHair } from '#entities/characterHair'
import characterHairRepository from '#repositories/characterHairRepository'

interface IPayload {}

export default class characterHairListEvent {
  constructor(
    private readonly io: Server,
    private readonly socket: TSocket
  ) {}

  public listen(): void {
    this.socket.on('character:hair:list', this.handleEvent.bind(this))
  }

  private async handleEvent(data: IPayload, callback: (response: CharacterHair[]) => void): Promise<void> {
    const items: CharacterHair[] = await characterHairRepository.getAllSelectable()
    await Database.getEntityManager().populate(items, ['sprite'])
    callback(items)
  }
}
